<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSignalStrengthSummaryOutput StructType
 * @subpackage Structs
 */
class GetSignalStrengthSummaryOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The LastActivity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\StructType\LastActivityOutput
     */
    public $LastActivity;
    /**
     * The CellSignalingSummary
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\StructType\CellSignalingSummaryOutput
     */
    public $CellSignalingSummary;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * Constructor method for GetSignalStrengthSummaryOutput
     * @uses GetSignalStrengthSummaryOutput::setSuccess()
     * @uses GetSignalStrengthSummaryOutput::setLastActivity()
     * @uses GetSignalStrengthSummaryOutput::setCellSignalingSummary()
     * @uses GetSignalStrengthSummaryOutput::setErrorMessage()
     * @param bool $success
     * @param \CustomerManagement\StructType\LastActivityOutput $lastActivity
     * @param \CustomerManagement\StructType\CellSignalingSummaryOutput $cellSignalingSummary
     * @param string $errorMessage
     */
    public function __construct($success = null, \CustomerManagement\StructType\LastActivityOutput $lastActivity = null, \CustomerManagement\StructType\CellSignalingSummaryOutput $cellSignalingSummary = null, $errorMessage = null)
    {
        $this
            ->setSuccess($success)
            ->setLastActivity($lastActivity)
            ->setCellSignalingSummary($cellSignalingSummary)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \CustomerManagement\StructType\GetSignalStrengthSummaryOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get LastActivity value
     * @return \CustomerManagement\StructType\LastActivityOutput|null
     */
    public function getLastActivity()
    {
        return $this->LastActivity;
    }
    /**
     * Set LastActivity value
     * @param \CustomerManagement\StructType\LastActivityOutput $lastActivity
     * @return \CustomerManagement\StructType\GetSignalStrengthSummaryOutput
     */
    public function setLastActivity(\CustomerManagement\StructType\LastActivityOutput $lastActivity = null)
    {
        $this->LastActivity = $lastActivity;
        return $this;
    }
    /**
     * Get CellSignalingSummary value
     * @return \CustomerManagement\StructType\CellSignalingSummaryOutput|null
     */
    public function getCellSignalingSummary()
    {
        return $this->CellSignalingSummary;
    }
    /**
     * Set CellSignalingSummary value
     * @param \CustomerManagement\StructType\CellSignalingSummaryOutput $cellSignalingSummary
     * @return \CustomerManagement\StructType\GetSignalStrengthSummaryOutput
     */
    public function setCellSignalingSummary(\CustomerManagement\StructType\CellSignalingSummaryOutput $cellSignalingSummary = null)
    {
        $this->CellSignalingSummary = $cellSignalingSummary;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \CustomerManagement\StructType\GetSignalStrengthSummaryOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
}
